%{							/* -*- C -*- */
#include <stdlib.h>
#include "parse-calc.h"
#define YY_DECL \
  int yylex (YYSTYPE *yylval, YYLTYPE *yylloc)

#define YYLLOC_COLUMNS(Col)			\
  yylloc->last_column += Col

#define YYLLOC_LINES(Lines)			\
  do {						\
    yylloc->last_line += Lines;			\
    yylloc->last_column = 0;			\
  } while (0)

#define YYLLOC_STEP()				\
  do {						\
    yylloc->first_line = yylloc->last_line;	\
    yylloc->first_column = yylloc->last_column;	\
  } while (0)

#define YY_USER_ACTION \
  YYLLOC_COLUMNS(yyleng);
%}

%option noyywrap
%option nounput

digit		[0-9]
integer		{digit}+
whitespace	[ \t\r]+

%%
%{
  YYLLOC_STEP();
%}
"+"		return PLUS;
"-"		return MINUS;
"*"		return TIMES;
"/"		return DIV;

{integer}	{
		  yylval->ival = atoi(yytext);
		  return INT;
		}

{whitespace}	YYLLOC_STEP();

.		return *yytext;
\n		YYLLOC_LINES(1); return *yytext;
%%
